<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 45.40</title>
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Ngọc Cậu</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
                 with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-item">
              <a href="pages/widgets.html" class="nav-link">
                <i class="nav-icon fas fa-th"></i>
                <p>
                  Widgets
                  <span class="right badge badge-danger">New</span>
                </p>
              </a>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Danh sách người dùng đăng ký</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Dashboard v1</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->
      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="container">
            <div class="row mb-3">
              <div class="col-sm-3">
                <button id="button-insert-user" class="btn btn-success">Thêm user</button>
              </div>
            </div>
            <div class="row">
              <div class="col-sm-12">
                <table id="table-user" class="table table-bordered">
                  <thead class="text-center font-weight-bold">
                    <td>Id</td>
                    <td>Firstname</td>
                    <td>Lastname</td>
                    <td>Country</td>
                    <td>Subject</td>
                    <td>Customer Type</td>
                    <td>Register Status</td>
                    <td>Action</td>
                  </thead>
                  <tbody>

                  </tbody>
                </table>
              </div>
              <!-- Vùng tạo modal-->
              <!-- Vùng tạo modal Insert User-->
              <div id="modal-insert-user" class="modal fade" tabindex="-1" role="dialog">
                <div class="modal-dialog" role="document">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title">Insert user</h5>
                      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                      </button>
                    </div>
                    <div class="modal-body">
                      <form action="insert-user">
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Firstname</label>
                          </div>
                          <div class="col-sm-8">
                            <input id="inp-insert-first-name" type="text" class="form-control"
                              placeholder="Nhập First Name">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Lastname</label>
                          </div>
                          <div class="col-sm-8">
                            <input id="inp-insert-last-name" type="text" class="form-control"
                              placeholder="Nhập Lastname Name">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Subject</label>
                          </div>
                          <div class="col-sm-8">
                            <input id="inp-insert-subject" type="text" class="form-control" placeholder="Nhập SUbject">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Country</label>
                          </div>
                          <div class="col-sm-8">
                            <select class="form-control" name="country" id="select-insert-country">
                              <option value=""></option>
                              <option value="VN">Việt Nam</option>
                              <option value="USA">Mỹ</option>
                              <option value="AUS">Australia</option>
                              <option value="CAN">Canada</option>
                            </select>
                          </div>
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button id="button-new-user" type="button" class="btn btn-success">Insert User</button>
                      <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                  </div>
                </div>
              </div>

              <!-- Vùng tạo modal Fix User-->
              <div id="modal-fix-user" class="modal fade" tabindex="-1" role="dialog">
                <div class="modal-dialog" role="document">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title">Insert user</h5>
                      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                      </button>
                    </div>
                    <div class="modal-body">
                      <form action="insert-user">
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Firstname</label>
                          </div>
                          <div class="col-sm-8">
                            <input id="inp-update-first-name" type="text" class="form-control"
                              placeholder="Nhập First Name">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Lastname</label>
                          </div>
                          <div class="col-sm-8">
                            <input id="inp-update-last-name" type="text" class="form-control"
                              placeholder="Nhập Lastname Name">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Subject</label>
                          </div>
                          <div class="col-sm-8">
                            <input id="inp-update-subject" type="text" class="form-control" placeholder="Nhập SUbject">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Country</label>
                          </div>
                          <div class="col-sm-8">
                            <select class="form-control" name="country" id="select-update-country">
                              <option value=""></option>
                              <option value="VN">Việt Nam</option>
                              <option value="USA">Mỹ</option>
                              <option value="AUS">Australia</option>
                              <option value="CAN">Canada</option>
                            </select>
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Customer Type</label>
                          </div>
                          <div class="col-sm-8">
                            <select class="form-control" name="country" id="select-update-customer-type">
                              <option value=""></option>
                              <option value="Standard">Standard</option>
                              <option value="Gold">Gold</option>
                              <option value="Premium">Premium</option>
                            </select>
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="">Register Status</label>
                          </div>
                          <div class="col-sm-8">
                            <select class="form-control" name="country" id="select-update-register-status">
                              <option value=""></option>
                              <option value="Accepted">Accepted</option>
                              <option value="Denied">Denied</option>
                              <option value="Standard">Standard</option>
                            </select>
                          </div>
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button id="button-update-user" type="button" class="btn btn-success">Update User</button>
                      <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                  </div>
                </div>
              </div>
            </div><!-- /.container-fluid -->
      </section>
      <!-- /.content -->
    </div>
    <!-- ./wrapper -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2022 Devcamp.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 1.0.0
      </div>
    </footer>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <script>
      $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gNAME_COL = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"]
        const gCOL_ID = 0;
        const gCOL_FIRST_NAME = 1;
        const gCOL_LAST_NAME = 2;
        const gCOL_COUNTRY = 3;
        const gCOL_SUBJECT = 4;
        const gCOL_CUSTOMER_TYPE = 5;
        const gCOL_REGISTER_STATUS = 6;
        const gCOL_ACTION = 7;
        const gBASE_URL = "http://42.115.221.44:8080/crud-api/users/";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading();
        //** Khu vực chứa các hàm liên quan đến CRUP
        // Hàm ấn nút Thêm dữ liệu
        $("#button-insert-user").on("click", function () {
          onBtnInsertClick();
        });
        // Hàm ấn nút Sửa dữ liệu
        $(document).on("click", "#table-user .btn-fix", function () {
          onBtnFixClick(this);
        });
        // Hàm ấn nút xóa dữ liệu
        $(document).on("click", "#table-user .btn-delete", function () {
          onBtnDeleteClick(this);
        });
        //**
        //** Khu vực chứa các nút liên quan đến làm việc với sever
        // Hàm ấn nút Insert User trên modal
        $("#button-new-user").click(function () {
          onBtnNewUserClick();
        });
        // Hàm xử lý ấn nút Update user
        $("#button-update-user").on("click", function () {
          onBtnUpdateClick();
        });
        //**

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm load trang để cập nhật bảng
        function onPageLoading() {
          "use strict";
          $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json",
            success: function (response) {
              getDisplayDataAllUser(response);
            },
            error: function (response) {
              alert("Gọi Api không thành công!")
            }
          })
        };
        //** khu vực chứa vùng làm việc để hiện Modal
        // Hàm ấn nút thêm dữ liệu 
        function onBtnInsertClick() {
          "use strict";
          $("#modal-insert-user").modal("show")
        }
        // Hàm ấn nút Fix dữ liệu 
        function onBtnFixClick(paramElement) {
          "use strict";
          const vData = 0;
          var vNewRow = $(paramElement).closest("tr");
          var vTable = $("#table-user").DataTable();
          var vDataRow = vTable.rows(vNewRow).data().draw();
          console.log(vDataRow[vData].id);
          $("#modal-fix-user").modal("show");
        };
        // hàm xử lý sự kiện xóa dữ liệu
        function onBtnDeleteClick(paramElement) {
          "use strict";
          const vData = 0;
          var vNewRow = $(paramElement).closest("tr");
          var vTable = $("#table-user").DataTable();
          var vDataRow = vTable.rows(vNewRow).data().draw();
          console.log(vDataRow[vData].id)
        };
        //**
        //** Khu vực chứa vùng làm việc liên quan đến làm việc với AJAX
        // Hàm xử lý sự kiện click nút Insert User trên Modal
        function onBtnNewUserClick() {
          "use strict";
          var vNewUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: ""
          }
          // Bước 1: thu thập thông tin 
          vNewUser.firstname = $("#inp-insert-first-name").val().trim();
          vNewUser.lastname = $("#inp-insert-last-name").val().trim();
          vNewUser.subject = $("#inp-insert-subject").val().trim();
          vNewUser.country = $("#select-insert-country").val();
          console.log(vNewUser);
          // Bước 2: Kiểm tra thông tin
          var vCheck = getCheckDataInsert(vNewUser);
          if (vCheck == false) {
            return
          }
          // Bước 3 gọi Api
          $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(vNewUser),
            success: function (response) {
              alert("Đã cập nhật dữ liệu thành công!");
              location.reload();
            },
            error: function (response) {
              alert("Cập nhật dữ liệu không thành công!")
            }
          })
        };
        // Hàm xử lý dữ liệu update user
        function onBtnUpdateClick() {
          "use strict";
          var vNewUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: ""
          }
          // Bước 1: thu thập thông tin 
          vNewUser.firstname = $("#inp-first-name").val().trim();
          vNewUser.lastname = $("#inp-last-name").val().trim();
          vNewUser.subject = $("#inp-subject").val().trim();
          vNewUser.country = $("#select-country").val();
          console.log(vNewUser);
          // Bước 2: Kiểm tra thông tin
          var vCheck = getCheckDataInsert(vNewUser);
          if (vCheck == false) {
            return
          }
          // Bước 3 gọi Api
          $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(vNewUser),
            success: function (response) {
              alert("Đã cập nhật dữ liệu thành công!");
              location.reload();
            },
            error: function (response) {
              alert("Cập nhật dữ liệu không thành công!")
            }
          })
        };
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function getDisplayDataAllUser(paramResponse) {
          "use strict";
          console.log(paramResponse);
          $("#table-user").DataTable({
            data: paramResponse,
            columns: [
              { data: gNAME_COL[gCOL_ID] },
              { data: gNAME_COL[gCOL_FIRST_NAME] },
              { data: gNAME_COL[gCOL_LAST_NAME] },
              { data: gNAME_COL[gCOL_COUNTRY] },
              { data: gNAME_COL[gCOL_SUBJECT] },
              { data: gNAME_COL[gCOL_CUSTOMER_TYPE] },
              { data: gNAME_COL[gCOL_REGISTER_STATUS] },
              { data: gNAME_COL[gCOL_ACTION] },
            ],
            columnDefs: [
              {
                targets: gCOL_ACTION,
                defaultContent: "<button class='btn btn-primary btn-fix'>Sửa</button>" + " " + "<button class='btn btn-danger btn-delete'>Xóa</button>"
              },
            ]
          })
          $("#table-user").width("auto")
        };

        // Hàm kiểm tra dữ liệu khi Insert trong modal
        function getCheckDataInsert(paramData) {
          "use strict";
          var vValue = 1;
          var vKey = 0;
          var vFound = true;
          var vNewArray = Object.entries(paramData);
          console.log(vNewArray);
          for (var bI = 0; bI < vNewArray.length; bI++) {
            if (vNewArray[bI][vValue] == "") {
              alert("Hãy điền vào ô " + vNewArray[bI][vKey]);
              vFound = false;
            }
          }
          return vFound;
        };

      })
    </script>
</body>

</html>